use crate::Entity;

#[derive(Debug, Entity, serde::Serialize, serde::Deserialize)]
#[microrm_internal]
pub struct Metaschema {
    pub key: String,
    pub value: String,
}


/* below this line is a manual expansion of the Entity derivation macro */

/*
#[derive(Clone,Copy)]
#[allow(unused)]
pub enum MetaschemaColumns {
    Key,
    Value
}

impl crate::model::EntityColumns for MetaschemaColumns {
    type Entity = Metaschema;
}

impl crate::model::Entity for Metaschema {
    fn table_name() -> &'static str { "metaschema" }
    type Column = MetaschemaColumns;
    fn column_count() -> usize {
        2
    }
    fn index(c: Self::Column) -> usize {
        c as usize
    }
    fn name(c: Self::Column) -> &'static str {
        match c {
            Self::Column::Key => "key",
            Self::Column::Value => "value"
        }
    }
    fn values(&self) -> Vec<&dyn crate::re_export::rusqlite::ToSql> {
        vec![ &self.key, &self.value ]
    }
}

*/
